program IsShift;
{ IsShift version 1.0 }
{ Copyright (c) 1996,1999  Marius Gedminas <mgedmin@takas.lt> }

{ $Id: isshift.pas,v 1.4 1999/08/25 20:38:52 mg Exp $ }

{ This program is free software; you can redistribute it and/or modify }
{ it under the terms of the GNU General Public License as published by }
{ the Free Software Foundation; either version 2 of the License, or    }
{ (at your option) any later version.                                  }
{                                                                      }
{ This program is distributed in the hope that it will be useful,      }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of       }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        }
{ GNU General Public License for more details.                         }
{                                                                      }
{ You should have received a copy of the GNU General Public License    }
{ along with this program; if not, write to the Free Software          }
{ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            }

{ Usage: IsShift <shift mask>                                          }
{ Shift mask one or more of the following (in any case):               }
{   lshift rshift shift alt ctrl caps num scroll                       }
{ Note: shift is same as specifying both lshift and rshift             }
{ Returns: ExitCode 0 - none down/active                               }
{          ExitCode 1 - one of specified keys is down/active           }
{          ExitCode 2 - all specified keys are down/active             }
{ See file testshif.bat for an example.                                }

{ History: }

{ 1996-03-18  Version 0.0 }
{   This is the last modification date of the old comment-less version.}
{   It was written for Borland Pascal 7.0.  Completely non-portable.   }

{ 1999-02-20  Version 1.0 }
{   Added many comments, placed under CVS source control and GPL'ed.   }

const
  { Keyboard state and shift masks }
  kbRightShift  = $0001;
  kbLeftShift   = $0002;
  kbCtrlShift   = $0004;
  kbAltShift    = $0008;
  kbScrollState = $0010;
  kbNumState    = $0020;
  kbCapsState   = $0040;
  kbInsState    = $0080;

var
  Mask, Ret: Word;
  I: Byte;
  S: string;

function Upper(S: string): string;
var
  I: Byte;
begin
  for I := 1 to Length(S) do S[I] := UpCase(S[I]);
  Upper := S;
end;

begin
  Mask := 0;
  for I := 1 to ParamCount do
    begin
      S := Upper(ParamStr(I));
      if S = 'SHIFT' then Mask := Mask or (kbLeftShift or kbRightShift)
      else
      if S = 'LSHIFT' then Mask := Mask or kbLeftShift
      else
      if S = 'RSHIFT' then Mask := Mask or kbRightShift
      else
      if S = 'CTRL' then Mask := Mask or kbCtrlShift
      else
      if S = 'ALT' then Mask := Mask or kbAltShift
      else
      if S = 'CAPS' then Mask := Mask or kbCapsState
      else
      if S = 'NUM' then Mask := Mask or kbNumState
      else
      if S = 'SCROLL' then Mask := Mask or kbScrollState
      else
    end;
  if Mask = 0 then
    begin
      WriteLn('IsShift v1.0  Copyright (c) 1996,1999  M. Gedminas <mgedmin@takas.lt>');
      WriteLn('This program is Free Software.  See file COPYING for details.');
      WriteLn('Usage: IsShift <shift mask>');
      WriteLn('Shift mask one or more of the following (in any case):');
      WriteLn('  lshift rshift shift alt ctrl caps num scroll');
      WriteLn('Note: shift is same as specifying both lshift and rshift');
      WriteLn('Returns: ERRORLEVEL 0 - none down/active');
      WriteLn('         ERRORLEVEL 1 - one of specified keys is down/active');
      WriteLn('         ERRORLEVEL 2 - all specified keys are down/active');
      WriteLn('See file testshif.bat for an example.');
      Halt(0);
    end;
  Ret := Mem[Seg0040:$17] and Mask;
  if Ret = Mask then Halt(2)
  else if Ret <> 0 then Halt(1)
  else Halt(0);
end.
