; KeyShow.com v1.02
; Copyright (c) 1996,1998,1999  M. Gedminas <mgedmin@takas.lt>
;
; $Id: keyshow.asm,v 1.4 1999/08/25 20:38:52 mg Exp $
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
; History:
;
; 1997-11-25  Version 1.00
;   The last modification date of that version.  It says (c) 1996.
;
; 1998-06-01  Version 1.01
;   The last modification date of that version.
;
; 1999-02-20  Version 1.02
;   Added many comments, placed under CVS source control and GPL'ed.
;
;
; Bugs: Shift-PrtScr leaves Shift in key flags
;       May be a little unstable if you are pressing Pause
;       Does not know Win95 keys (and other additional keys in some keybrds.)
;
; Notes:
;   PrtScr       =      E0 2A  (E0 37)+ E0 B7  E0 AA  (same as RShift-PrtScr)
;   Ctrl-PrtScr  =  Ctrl down  (E0 37)+ E0 B7  Ctrl up
;   Alt-PrtScr   =   Alt down     (54)+ D4     Alt up
;   Shift-PrtScr = Shift down  (E0 37)+ E0 B7  Shift up
; (Pause doesn't repeat: when you press it, you get MAKE and BREAK codes instantly)
;   Pause        =             E1 1D 45 E1 9D C5
;   Ctrl-Pause   =  Ctrl down     E0 46 E0 C6     Ctrl up
;   Alt-Pause    =   Alt down  E1 1D 45 E1 9D C5  Alt up
;   Shift-Pause  = Shift down  E1 1D 45 E1 9D C5  Shift up

ver             equ     '1.02'

code            segment
                assume  cs:code, ds:code

                org     100h

begin:          jmp     Main

; Data

Copyright       db      13, 10, 10, 10
                db      'KeyShow v', ver, '  Copyright (c) 1996,98,99  M. Gedminas <mgedmin@takas.lt>', 13, 10
                db      'This program is Free Software.  See file COPYING for details.', 13, 10, '$'

VideoSeg        dw      0B800h
VideoSize       equ     80*50

NoCursor        equ     2000h
StdCursor       equ     0607h

StatePos1       equ     (5*80+72)*2
StateBitPos1    equ     (5*80+62)*2
StatePos2       equ     (6*80+72)*2
StateBitPos2    equ     (6*80+62)*2
StatePos3       equ     (4*80+72)*2
StateBitPos3    equ     (4*80+62)*2
StatePos4       equ     (3*80+72)*2
StateBitPos4    equ     (3*80+62)*2

QueuePos        equ     (0*80+1)*2              ; = (0*80+1)*2

QSize           equ     26                      ; = 79 div 3
Queue           db      QSize dup (0)
QPtr            dw      0

QueuePos2       equ     (1*80+1)*2              ; = (1*80+1)*2
QSize2          equ     15                      ; = 79 div 5
Queue2          dw      QSize2 dup (0)
QPtr2           dw      0

Keys            db      128 dup (0)

Origin          equ     5*80+5

FirstKeys       db       0, 0, 'Es'             ; *1
                db       3, 3, '1!'             ;  2
                db       6, 3, '2@'             ;  3
                db       9, 3, '3#'             ;  4
                db      12, 3, '4$'             ;  5
                db      15, 3, '5%'             ;  6
                db      18, 3, '6^'             ;  7
                db      21, 3, '7&'             ;  8
                db      24, 3, '8*'             ;  9
                db      27, 3, '9('             ;  A
                db      30, 3, '0)'             ;  B
                db      33, 3, '-_'             ;  C
                db      36, 3, '=+'             ;  D

BackKey         db      42, 3, '<--'            ;  E

TabKey          db       0, 5, 'Tab'            ; *F

Letters1        db       4, 5, 'Qq'             ; *10
                db       7, 5, 'Ww'             ;  11
                db      10, 5, 'Ee'             ;  12
                db      13, 5, 'Rr'             ;  13
                db      16, 5, 'Tt'             ;  14
                db      19, 5, 'Yy'             ;  15
                db      22, 5, 'Uu'             ;  16
                db      25, 5, 'Ii'             ;  17
                db      28, 5, 'Oo'             ;  18
                db      31, 5, 'Pp'             ;  19
                db      34, 5, '[{'             ;  1A
                db      37, 5, ']}'             ;  1B

EnterKey1       db      40, 5,   '     '        ; *1C - Enter
EnterKey2       db      40, 6,   ' <  '
EnterKey3       db      38, 7, ' Enter '

CtrlKey         db      0, 11, 'Ctrl'           ; *1D

Letters2        db       5, 7, 'Aa'             ; *1E
                db       8, 7, 'Ss'             ;  1F
                db      11, 7, 'Ds'             ;  20
                db      14, 7, 'Fs'             ;  21
                db      17, 7, 'Gs'             ;  22
                db      20, 7, 'Hs'             ;  23
                db      23, 7, 'Js'             ;  24
                db      26, 7, 'Ks'             ;  25
                db      29, 7, 'Ls'             ;  26
                db      32, 7, ';:'             ;  27
                db      35, 7, 27h, '"'         ;  28
                db       0, 3, '`~'             ;  29

ShiftKey        db       0, 9, 'Shift'          ; *2A

Letters3        db      39, 3, '\|'             ; *2B
                db       6, 9, 'Zz'             ;  2C
                db       9, 9, 'Xx'             ;  2D
                db      12, 9, 'Cc'             ;  2E
                db      15, 9, 'Vv'             ;  2F
                db      18, 9, 'Bb'             ;  30
                db      21, 9, 'Nn'             ;  31
                db      24, 9, 'Mm'             ;  32
                db      27, 9, ',<'             ;  33
                db      30, 9, '.>'             ;  34
                db      33, 9, '/?'             ;  35

RShiftKey       db      36, 9, '  Shift  '      ; *36

StarKey         db      63, 3, '* '             ; *37
AltKey          db      7, 11, 'Alt'            ; *38
SpaceKey        db      11, 11, '[                     ]' ; *39
CapsKey         db       0, 7, 'Caps'           ; *3A

FnKeys          db       6, 0, 'F1'             ; *3B
                db       9, 0, 'F2'             ;  3C
                db      12, 0, 'F3'             ;  3D
                db      15, 0, 'F4'             ;  3E
                db      20, 0, 'F5'             ;  3F
                db      23, 0, 'F6'             ;  40
                db      26, 0, 'F7'             ;  41
                db      29, 0, 'F8'             ;  42
                db      34, 0, 'F9'             ;  43
                db      37, 0, 'F0'             ;  44

NumKey          db      57, 3, 'Nu'             ; *45
ScrollKey       db      50, 0, 'Sc'             ; *46

Cursor1         db      57, 5, 'Ho'             ; *47
                db      60, 5, '^^'             ;  48
                db      63, 5, 'PU'             ;  49
                db      66, 3, '- '             ;  4A
                db      57, 7, '<-'             ;  4B
                db      60, 7, '5 '             ;  4C
                db      63, 7, '->'             ;  4D

PlusKey1        db      66, 5, '  '             ; *4E - Plus
PlusKey2        db      66, 6, '+ '
PlusKey3        db      66, 7, '  '

Cursor2         db      57, 9, 'En'             ; *4F
                db      60, 9, 'vv'             ;  50
                db      63, 9, 'PD'             ;  51

InsKey          db      57, 11, ' Ins '         ; *52
DelKey          db      63, 11, 'De'            ; *53

PrtScr          db      47, 0, 'PS'             ; *54 or 77 (E0 37)

                                                ; *55 - 56 - ?

F1nKeys         db      40, 0, 'F1'             ; *57
                db      43, 0, 'F2'             ;  58

RCursor1        db      53, 0, 'Pa'             ; *66 (E0 46) - Pause
                db      50, 3, 'Ho'             ;  67 (E0 47)
                db      50, 9, '^^'             ;  68 (E0 48)
                db      53, 3, 'PU'             ;  69 (E0 49)

RLeftKey        db      47,11, '<-'             ; *6B (E0 4B)
RRightKey       db      53,11, '->'             ;  6D (E0 4D)

RCursor2        db      50, 5, 'En'             ; *6F (E0 4F)
                db      50,11, 'vv'             ;  70 (E0 50)
                db      53, 5, 'PD'             ;  71 (E0 51)
                db      47, 3, 'In'             ;  72 (E0 52)
                db      47, 5, 'De'             ;  73 (E0 53)

RSlashKey       db      60, 3, '/ '             ; *75 (E0 35)

RAltKey         db      35,11, 'Alt'            ; *78 (E0 38)

REnterKey1      db      66, 9, '  '             ; *7C (E0 1C)
REnterKey2      db      66,10, '<'             ;
REnterKey3      db      66,11, '  '             ;

RCtrlKey        db      41,11, 'Ctrl'           ; *7D (E0 1D)

; Extended keys: REnter (1C), RCtrl (1D), RSlash (35), RAlt (38)
;                       [7C]        [7D]         [75]       [78]
; Home (47), Up (48), PU (49), Left (4B), Right (4D), End (4F), Down (50), PD (51), Ins (52), Del (53)
;      [67]     [68]     [69]       [6B]        [6D]      [6F]       [70]     [71]      [72]      [73]
; Extended key code = scan code OR 60h

; PrtScr = [...] E0 37 or 54
; Pause = E1 1D 45
; Ctrl-Pause (Break) = E0 46

RightChar       db      ''
BottomChar      db      ''

HexChars        db      '0123456789ABCDEF'
BinChars        db      '.1'

Prefix          db      0

Old09           dd      0

; Main code
Main            proc    near

                call    GetVideo

                mov     cx, NoCursor
                call    SetCursor

                mov     al, ' '
                mov     ah, 1Fh
                call    FillScreen

                call    DrawKeyboard

                call    DrawQueue
                call    DrawQueue2
                call    DrawState

                call    InstallVector

MainLoop1:
                cmp     Keys[1], 0
                jz      MainLoop1
MainLoop2:
                cmp     Keys[1], 0
                jnz     MainLoop2

                call    RestoreVector

                call    ClearKeyb

                mov     al, ' '
                mov     ah, 0Fh
                call    FillScreen

                mov     cx, StdCursor
                call    SetCursor

                mov     dx, offset Copyright
                mov     ah, 09h
                int     21h

                ret
Main            endp

; Draws a key: calls DoDrawUp/Down according to Keys[AL]
DoDraw          proc    near

                xor     ah, ah
                mov     si, offset Keys
                add     si, ax
                cmp     byte ptr [si], 0
                jz      DoDrawUp
                jmp     DoDrawDown

DoDraw          endp

; Draws a released key: DS:BX -> record X, Y: Byte; Text: array[1..CX] of Char end;
DoDrawUp        proc    near

                mov     ax, VideoSeg
                mov     es, ax
                mov     al, 80
                mul     byte ptr [bx+1]
                add     al, [bx]
                adc     ah, 0
                add     ax, Origin
                shl     ax, 1
                mov     di, ax
                push    di
                push    cx

                mov     si, bx
                add     si, 2
                mov     ah, 3Fh
TextUp:         lodsb
                stosw
                loop    TextUp
                mov     ah, 10h
                mov     al, RightChar
                stosw

                pop     cx
                pop     di
                mov     al, BottomChar
                cmp     al, 0
                jz      DontDrawBottom
                mov     ah, 10h
                add     di, 80*2+2
                rep stosw
DontDrawBottom:

                retn
DoDrawUp        endp

; Draws a pressed key: DS:BX -> record X, Y: Byte; Text: array[1..CX] of Char end;
DoDrawDown      proc    near

                mov     ax, VideoSeg
                mov     es, ax
                mov     al, 80
                mul     byte ptr [bx+1]
                add     al, [bx]
                adc     ah, 0
                add     ax, Origin
                shl     ax, 1
                mov     di, ax
                push    di
                push    cx

                mov     ah, 1Fh
                mov     al, ' '
                stosw
                mov     si, bx
                add     si, 2
                mov     ah, 3Eh
TextDown:       lodsb
                stosw
                loop    TextDown

                pop     cx
                pop     di
                cmp     BottomChar, 0
                jz      DontClearBottom
                add     di, 80*2+2
                mov     ah, 1Fh
                mov     al, ' '
                rep stosw

DontClearBottom:
                retn
DoDrawDown      endp


; Draws a key in AL
DrawKey         proc    near

                mov     RightChar, ''
                mov     BottomChar, ''
                xor     bx, bx
                mov     bl, al
                mov     cx, 2

                cmp     al, 0
                jnz     Keys01toFF
                jmp     ExitDraw
Keys01toFF:
                cmp     al, 0Eh
                je      Keys0E
                cmp     al, 0Fh
                je      Keys0F
                ja      Keys10toFF

                ; 01 - 0D
                dec     bl
                shl     bx, cl
                add     bx, offset FirstKeys
                jmp     Ok

Keys0E:
                ; 0E
                mov     bx, offset BackKey
                mov     cx, 3
                jmp     Ok

Keys0F:
                ; 0F
                mov     bx, offset TabKey
                mov     cx, 3
                jmp     Ok

Keys10toFF:     cmp     al, 1Ch
                je      Keys1C
                cmp     al, 1Dh
                je      Keys1D
                ja      Keys1EtoFF

                ; 10 - 1B
                sub     bl, 10h
                shl     bx, cl
                add     bx, offset Letters1
                jmp     Ok

Keys1C:
                ; 1C - Enter
                mov     RightChar, ''
                mov     BottomChar, 0
                mov     bx, offset EnterKey1
                mov     cx, 5
                call    DoDraw
                
                mov     RightChar, ''
                mov     bx, offset EnterKey2
                mov     cx, 5
                mov     al, 1Ch
                call    DoDraw

                mov     BottomChar, ''
                mov     bx, offset EnterKey3
                mov     cx, 7
                mov     al, 1Ch
                jmp     Ok
Keys1D:
                ; 1D
                mov     bx, offset CtrlKey
                mov     cx, 4
                jmp     Ok

Keys1EtoFF:     cmp     al, 2Ah
                je      Keys2A
                ja      Keys2BtoFF
                ; 1E - 29
                sub     bl, 1Eh
                shl     bx, cl
                add     bx, offset Letters2
                jmp     Ok

Keys2A:
                ; 2A
                mov     bx, offset ShiftKey
                mov     cx, 5
                jmp     Ok

Keys2BtoFF:
                cmp     al, 36h
                je      Keys36
                cmp     al, 37h
                je      Keys37
                cmp     al, 38h
                je      Keys38
                cmp     al, 39h
                je      Keys39
                cmp     al, 3Ah
                je      Keys3A
                ja      Keys3BtoFF
                ; 2B - 35
                sub     bl, 2Bh
                shl     bx, cl
                add     bx, offset Letters3
                jmp     Ok

Keys36:
                ; 36
                mov     bx, offset RShiftKey
                mov     cx, 9
                jmp     Ok

Keys37:
                ; 37
                mov     bx, offset StarKey
                mov     cx, 2
                jmp     Ok
Keys38:
                ; 38
                mov     bx, offset AltKey
                mov     cx, 3
                jmp     Ok
Keys39:
                ; 39
                mov     bx, offset SpaceKey
                mov     cx, 23
                jmp     Ok
Keys3A:
                ; 3A
                mov     bx, offset CapsKey
                mov     cx, 4
                jmp     Ok

Keys3BtoFF:
                cmp     al, 45h
                je      Keys45
                cmp     al, 46h
                je      Keys46
                ja      Keys47toFF
                ; 3B - 44
                sub     bl, 3Bh
                shl     bx, cl
                add     bx, offset FnKeys
                jmp     Ok

Keys45:
                ; 45
                mov     bx, offset NumKey
                mov     cx, 2
                jmp     Ok
Keys46:
                ; 46
                mov     bx, offset ScrollKey
                mov     cx, 2
                jmp     Ok
Keys47toFF:
                cmp     al, 4Eh
                je      Keys4E
                ja      Keys4FtoFF
                ; 47 - 4D
                sub     bl, 47h
                shl     bx, cl
                add     bx, offset Cursor1
                jmp     Ok

Keys4E:
                ; 4E - Plus
                mov     RightChar, ''
                mov     BottomChar, 0
                mov     bx, offset PlusKey1
                mov     cx, 2
                call    DoDraw
                
                mov     RightChar, ''
                mov     bx, offset PlusKey2
                mov     cx, 2
                mov     al, 4Eh
                call    DoDraw

                mov     BottomChar, ''
                mov     bx, offset PlusKey3
                mov     cx, 2
                mov     al, 4Eh
                jmp     Ok

Keys4FtoFF:
                cmp     al, 52h
                je      Keys52
                cmp     al, 53h
                je      Keys53
                cmp     al, 54h
                je      Keys54
                ja      Keys55toFF
                ; 4F - 51
                sub     bl, 4Fh
                shl     bx, cl
                add     bx, offset Cursor2
                jmp     Ok

Keys52:
                ; 52
                mov     bx, offset InsKey
                mov     cx, 5
                jmp     Ok
Keys53:
                ; 53
                mov     bx, offset DelKey
                mov     cx, 2
                jmp     Ok
Keys54:
                ; 54
                mov     bx, offset PrtScr
                mov     cx, 2
                jmp     Ok

Keys55toFF:
                cmp     al, 57h
                jb      Keys54to56
                cmp     al, 58h
                ja      Keys59toFF
                ; 57 - 58
                sub     bl, 57h
                shl     bx, cl
                add     bx, offset F1nKeys
                jmp     Ok

Keys54to56:
                jmp     ExitDraw
Keys59toFF:
                cmp     al, 66h
                jae     Keys66toFF
                jmp     ExitDraw

Keys66toFF:
                cmp     al, 69h
                ja      Keys6AtoFF
                ; 66 - 69
                sub     bl, 66h
                shl     bx, cl
                add     bx, offset RCursor1
                jmp     Ok

Keys6AtoFF:
                cmp     al, 6Bh
                je      Keys6B
                cmp     al, 6Dh
                je      Keys6D
                cmp     al, 6Fh
                jb      ExitDraw
                cmp     al, 73h
                ja      Keys74toFF
                ; 6F - 73
                sub     bl, 6Fh
                shl     bx, cl
                add     bx, offset RCursor2
                jmp     Ok

Keys6B:
                ; 6B
                mov     bx, offset RLeftKey
                jmp     Ok
Keys6D:
                ; 6D
                mov     bx, offset RRightKey
                jmp     Ok

Keys74toFF:
                cmp     al, 75h
                je      Keys75
                cmp     al, 78h
                je      Keys78
                cmp     al, 7Ch
                je      Keys7C
                cmp     al, 7Dh
                je      Keys7D
                jmp     ExitDraw

Keys75:
                ; 75
                mov     bx, offset RSlashKey
                jmp     Ok
Keys78:
                ; 78
                mov     bx, offset RAltKey
                mov     cx, 3
                jmp     Ok
Keys7C:
                ; 7C - Right Enter
                mov     BottomChar, 0
                mov     bx, offset REnterKey1
                mov     cx, 2
                call    DoDraw
                
                mov     RightChar, ''
                mov     bx, offset REnterKey2
                mov     cx, 2
                mov     al, 7Ch
                call    DoDraw

                mov     BottomChar, ''
                mov     bx, offset REnterKey3
                mov     cx, 2
                mov     al, 7Ch
                jmp     Ok

Keys7D:
                ; 7D
                mov     bx, offset RCtrlKey
                mov     cx, 4
                jmp     Ok

Ok:
                call    DoDraw
ExitDraw:

                ret
DrawKey         endp

; Draws the whole keyboard
DrawKeyboard    proc    near

                mov     al, 0
                mov     cx, 128
KeyLoop:
                push    cx
                mov     al, cl
                call    DrawKey
                pop     cx
                loop    KeyLoop

                ret
DrawKeyboard    endp

; Draws key queue
DrawQueue       proc    near

                mov     ax, VideoSeg
                mov     es, ax
                mov     di, QueuePos
                mov     si, offset Queue
                mov     bx, offset HexChars
                mov     dx, QSize
                sub     dx, QPtr
                mov     cx, QSize
                mov     ah, 1Bh
                cld
DrawByte:
                cmp     cx, dx
                jne     NotHead1
                mov     ah, 1Ah
NotHead1:
                lodsb
                push    ax

                shr     al, 1
                shr     al, 1
                shr     al, 1
                shr     al, 1
                segcs xlat
                stosw

                pop     ax
                and     al, 0Fh
                segcs xlat
                stosw
                add     di, 2

                cmp     cx, dx
                jne     NotHead2
                mov     ah, 1Bh
NotHead2:
                loop    DrawByte

                ret
DrawQueue       endp

; Draws key queue 2
DrawQueue2      proc    near

                mov     ax, VideoSeg
                mov     es, ax
                mov     di, QueuePos2
                mov     si, offset Queue2
                mov     bx, offset HexChars
                mov     dx, QSize2
                sub     dx, QPtr2
                mov     cx, QSize2
                mov     ah, 1Bh
                cld
DrawByte2:
                cmp     cx, dx
                jne     NotHead12
                mov     ah, 1Ah
NotHead12:
                lodsb
                push    ax
                lodsb

                push    ax
                shr     al, 1
                shr     al, 1
                shr     al, 1
                shr     al, 1
                segcs xlat
                stosw

                pop     ax
                and     al, 0Fh
                segcs xlat
                stosw

                pop     ax
                push    ax
                shr     al, 1
                shr     al, 1
                shr     al, 1
                shr     al, 1
                segcs xlat
                stosw

                pop     ax
                and     al, 0Fh
                segcs xlat
                stosw

                add     di, 2

                cmp     cx, dx
                jne     NotHead22
                mov     ah, 1Bh
NotHead22:
                loop    DrawByte2

                ret
DrawQueue2      endp

; Auxiliary to DrawState
DrawBits        proc    near
; ES:DI -> ptr to video mem (hex)
; ES:SI -> ptr to video mem (bin)
; DL = value

                mov     bx, offset HexChars
                cld
                mov     ah, 1Eh

                mov     al, dl
                shr     al, 4
                segcs xlat
                stosw
                mov     al, dl
                and     al, 0Fh
                segcs xlat
                stosw

                mov     bx, offset BinChars
                mov     di, si
                mov     cx, 8
                mov     al, dl
                rol     al, 1
DrawBit1:
                push    ax
                and     al, 1
                segcs xlat
                stosw
                pop     ax
                rol     al, 1
                cmp     cx, 5
                jne     NoSkip1
                add     di, 2
NoSkip1:
                loop    DrawBit1

                ret
DrawBits        endp

; Draws keyboard state
DrawState       proc    near

                mov     ax, 40h
                mov     es, ax
                mov     dx, es:[17h]

                mov     ax, VideoSeg
                mov     es, ax

                mov     di, StatePos2
                mov     si, StateBitPos2
                call    DrawBits

                mov     di, StatePos1
                mov     si, StateBitPos1
                mov     dl, dh
                call    DrawBits

                mov     ax, 40h
                mov     es, ax
                mov     dx, es:[96h]

                mov     ax, VideoSeg
                mov     es, ax

                mov     di, StatePos3
                mov     si, StateBitPos3
                call    DrawBits

                mov     di, StatePos4
                mov     si, StateBitPos4
                mov     dl, dh
                call    DrawBits

                ret
DrawState       endp

; Adds a key to queue
AddToQueue      proc    near

                push    cs
                pop     ds
                mov     bx, QPtr
                inc     bx
                cmp     bx, QSize
                jne     NoWrap
                mov     bx, 0
NoWrap:
                mov     QPtr, bx
                mov     Queue[bx], al

                push    ax
                call    DrawQueue
                pop     ax

                ret
AddToQueue      endp

; Adds a key to queue 2
AddToQueue2     proc    near

                push    cs
                pop     ds
                mov     bx, QPtr2
                inc     bx
                cmp     bx, QSize2
                jne     NoWrap2
                mov     bx, 0
NoWrap2:
                mov     QPtr2, bx
                shl     bx, 1
                mov     Queue2[bx], ax

                call    DrawQueue2

                ret
AddToQueue2     endp

; INT 09h handler
Int09           proc

                push    ax
                push    bx
                push    cx
                push    dx
                push    si
                push    di
                push    bp
                push    ds
                push    es

                push    cs
                pop     ds

                in      al, 60h
                call    AddToQueue

                cmp     al, 0E0h
                je      KeyPrefix
                cmp     al, 0E1h
                je      PausePrefix
                cmp     al, 0FFh
                je      ExitInt
                js      KeyRelease
KeyPress:


                mov     dl, 1
                jmp     short DoKey
KeyRelease:
                and     al, not 80h
                mov     dl, 0
DoKey:
                ; Check for Prefix
                cmp     Prefix, 0
                jz      OkKey
                dec     Prefix
                cmp     Prefix, 1 ; was E1?
                je      AbortInt
                ; Make extended scancode
                or      al, 60h
                cmp     al, 77h ; PrtScr
                je      SpecPrtScr
                cmp     al, 65h ; Pause
                je      SpecPause
                cmp     al, 66h ; Ctrl-Pause
                je      SpecKey

OkKey:
                xor     bx, bx
                mov     bl, al
                mov     cs:Keys[bx], dl

                call    DrawKey

                jmp     ExitInt
PausePrefix:
                mov     Prefix, 2
                jmp     AbortInt
KeyPrefix:
                mov     Prefix, 1
ExitInt:

                pushf
                call    Old09

                call    DrawState

                mov     ax, 40h
                mov     es, ax
                mov     ax, es:[1Ah]
                cmp     ax, es:[1Ch]
                je      BufferEmpty

                mov     es:[1Ch], ax
                mov     bx, ax

                mov     ax, es:[bx]
                call    AddToQueue2

BufferEmpty:
                pop     es
                pop     ds
                pop     bp
                pop     di
                pop     si
                pop     dx
                pop     cx
                pop     bx
                pop     ax

                iret

;PausePrefix:
;                ; Clear key - E1
;                in      al, 61h
;                mov     ah, al
;                or      al, 80h
;                out     61h, al
;                mov     al, ah
;                out     61h, al
;
;                in      al, 60h
;
;                ; Clear key - 1D or 9D
;                in      al, 61h
;                mov     ah, al
;                or      al, 80h
;                out     61h, al
;                mov     al, ah
;                out     61h, al
;
;                in      al, 60h
;                ; AL = 45 or C5
;                or      al, al
;                mov     al, 66h
;                mov     dl, 0
;                js      SpecKey
;                mov     dl, 1
;                jmp     SpecKey
;
SpecPause:
                mov     al, 66h
                jmp     SpecKey
SpecPrtScr:
                mov     al, 54h
SpecKey:
                xor     bx, bx
                mov     bl, al
                mov     cs:Keys[bx], dl
                mov     Prefix, 0

                call    DrawKey

AbortInt:
                ; Clear key
                in      al, 61h
                mov     ah, al
                or      al, 80h
                out     61h, al
                mov     al, ah
                out     61h, al

                ; Send EOI
                mov    al, 20h
                out    20h, al

                pop     es
                pop     ds
                pop     bp
                pop     di
                pop     si
                pop     dx
                pop     cx
                pop     bx
                pop     ax

                iret
Int09           endp

; Installs own keyboard vector
InstallVector   proc    near

                mov     ax, 3509h
                int     21h
                mov     word ptr Old09[0], bx
                mov     word ptr Old09[2], es

                mov     ax, 2509h
                mov     dx, offset Int09
                int     21h

                ret
InstallVector   endp

; Restores original keyboard vector
RestoreVector   proc    near

                mov     dx, word ptr Old09[0]
                mov     ax, word ptr Old09[2]
                mov     ds, ax
                mov     ax, 2509h
                int     21h

                push    cs
                pop     ds

                ret
RestoreVector   endp

; Returns segment of video memory in VideoSeg
GetVideo        proc    near

                mov     ah, 0Fh
                int     10h
                cmp     al, 07h
                jne     NotMono

                mov     VideoSeg, 0B000h
                jmp     DoneWithVideo

NotMono:
                mov     VideoSeg, 0B800h
                and     al, 0FEh
                cmp     al, 02h
                je      DoneWithVideo

                mov     ax, 03h
                int     10h

DoneWithVideo:

                ret
GetVideo        endp

; Sets cursor shape in CX
SetCursor       proc    near

                mov     ah, 01h
                int     10h

                retn
SetCursor       endp

; Fills screen with character in AL and attribute in AH
FillScreen      proc    near

                mov     bx, VideoSeg
                mov     es, bx
                mov     di, 0
                mov     cx, VideoSize
                cld
                rep     stosw

                ret
FillScreen      endp

; Waits for a keypress and returns key code in AX
GetKey          proc    near

                mov     ah, 0
                int     16h

                ret
GetKey          endp

; Clears keyboard buffer
ClearKeyb       proc    near

                mov     ax, 40h
                mov     es, ax
                mov     ax, es:[1Ah]
                mov     es:[1Ch], ax

                ret
ClearKeyb       endp

code            ends
                end  begin


;   0....x....1....x....2....x....3....x....4....x....5....x....6....x..
; 0 Es   F1 F2 F3 F4   F5 F6 F7 F8   F9 F0 F1 F2   PS Sc Pa
; 1
; 2
; 3 `~ 1! 2@ 3# 4$ 5% 6^ 7& 8* 9( 0) -_ =+ \| <--  In Ho PU  Nu /  *  -
; 4
; 5 Tab Qq Ww Ee Rr Tt Yy Uu Ii Oo Pp [{ ]} [   ]  De En PD  Ho ^^ PU +
; 6                                         [   ]
; 7 Caps Aa Ss Dd Ff Gg Hh Jj Kk Ll ;: '" [Enter]            <- 5  ->
; 8
; 9 Shift Zz Xx Cc Vv Bb Nn Mm ,< .> /? [ Shift ]     ^^     En vv PD  
; 0
; 1 Ctrl   Alt [                     ] Alt   Ctrl  <- vv ->  [Ins] De <
